<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: OpenSim::AbstractInput Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_user.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For MATLAB, Python, Java, and C++ users</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('classOpenSim_1_1AbstractInput.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="classOpenSim_1_1AbstractInput-members.html">List of all members</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">OpenSim::AbstractInput Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">

<p>A specialized <a class="el" href="classOpenSim_1_1Socket.html">Socket</a> that connects to an <a class="el" href="classOpenSim_1_1Output.html">Output</a> signal is an <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a>.  
 <a href="classOpenSim_1_1AbstractInput.html#details">More...</a></p>
<div id="dynsection-0" onclick="return toggleVisibility(this)" class="dynheader closed" style="cursor:pointer;">
  <img id="dynsection-0-trigger" src="closed.png" alt="+"/> Inheritance diagram for OpenSim::AbstractInput:</div>
<div id="dynsection-0-summary" class="dynsummary" style="display:block;">
</div>
<div id="dynsection-0-content" class="dyncontent" style="display:none;">
 <div class="center">
  <img src="classOpenSim_1_1AbstractInput.png" usemap="#OpenSim::AbstractInput_map" alt=""/>
  <map id="OpenSim::AbstractInput_map" name="OpenSim::AbstractInput_map">
<area href="classOpenSim_1_1AbstractSocket.html" title="A Socket formalizes the dependency between a Component and another object (typically another Componen..." alt="OpenSim::AbstractSocket" shape="rect" coords="0,0,154,24"/>
<area href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;" alt="OpenSim::Input&lt; T &gt;" shape="rect" coords="0,112,154,136"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:aa5c9e6000a9e9f55c94e359e797bca33"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractInput.html#aa5c9e6000a9e9f55c94e359e797bca33">~AbstractInput</a> ()</td></tr>
<tr class="separator:aa5c9e6000a9e9f55c94e359e797bca33"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1495e040f3e49a876a554dafd0f44e80"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOpenSim_1_1AbstractInput.html">AbstractInput</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractInput.html#a1495e040f3e49a876a554dafd0f44e80">clone</a> () const override=0</td></tr>
<tr class="memdesc:a1495e040f3e49a876a554dafd0f44e80"><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a dynamically-allocated copy.  <a href="classOpenSim_1_1AbstractInput.html#a1495e040f3e49a876a554dafd0f44e80">More...</a><br /></td></tr>
<tr class="separator:a1495e040f3e49a876a554dafd0f44e80"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a10ae90fa015c07916d0986efe5e77144"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractInput.html#a10ae90fa015c07916d0986efe5e77144">connect</a> (const <a class="el" href="classOpenSim_1_1Object.html">Object</a> &amp;object) override</td></tr>
<tr class="memdesc:a10ae90fa015c07916d0986efe5e77144"><td class="mdescLeft">&#160;</td><td class="mdescRight">Connect this Socket to the provided connectee object.  <a href="classOpenSim_1_1AbstractInput.html#a10ae90fa015c07916d0986efe5e77144">More...</a><br /></td></tr>
<tr class="separator:a10ae90fa015c07916d0986efe5e77144"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0877b842472ab90608a3c0e761878f56"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractInput.html#a0877b842472ab90608a3c0e761878f56">connect</a> (const <a class="el" href="classOpenSim_1_1AbstractOutput.html">AbstractOutput</a> &amp;output, const std::string &amp;alias=&quot;&quot;)=0</td></tr>
<tr class="memdesc:a0877b842472ab90608a3c0e761878f56"><td class="mdescLeft">&#160;</td><td class="mdescRight">TODO.  <a href="classOpenSim_1_1AbstractInput.html#a0877b842472ab90608a3c0e761878f56">More...</a><br /></td></tr>
<tr class="separator:a0877b842472ab90608a3c0e761878f56"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae5efc02a932f1418e6c5f275404258b1"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractInput.html#ae5efc02a932f1418e6c5f275404258b1">connect</a> (const <a class="el" href="classOpenSim_1_1AbstractChannel.html">AbstractChannel</a> &amp;channel, const std::string &amp;alias=&quot;&quot;)=0</td></tr>
<tr class="memdesc:ae5efc02a932f1418e6c5f275404258b1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Connect this <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a> to a single output channel.  <a href="classOpenSim_1_1AbstractInput.html#ae5efc02a932f1418e6c5f275404258b1">More...</a><br /></td></tr>
<tr class="separator:ae5efc02a932f1418e6c5f275404258b1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1745b26a3e3263f5cafce0d4074cb809"><td class="memItemLeft" align="right" valign="top">virtual const std::string &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractInput.html#a1745b26a3e3263f5cafce0d4074cb809">getAlias</a> () const =0</td></tr>
<tr class="memdesc:a1745b26a3e3263f5cafce0d4074cb809"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the alias for a Channel.  <a href="classOpenSim_1_1AbstractInput.html#a1745b26a3e3263f5cafce0d4074cb809">More...</a><br /></td></tr>
<tr class="separator:a1745b26a3e3263f5cafce0d4074cb809"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a667e6b607e3d3b95fa768971219efd23"><td class="memItemLeft" align="right" valign="top">virtual const std::string &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractInput.html#a667e6b607e3d3b95fa768971219efd23">getAlias</a> (unsigned index) const =0</td></tr>
<tr class="memdesc:a667e6b607e3d3b95fa768971219efd23"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the alias for the Channel indicated by the provided index.  <a href="classOpenSim_1_1AbstractInput.html#a667e6b607e3d3b95fa768971219efd23">More...</a><br /></td></tr>
<tr class="separator:a667e6b607e3d3b95fa768971219efd23"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a955fc6683d49f3c5fc50c3e440da4669"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractInput.html#a955fc6683d49f3c5fc50c3e440da4669">setAlias</a> (const std::string &amp;alias)=0</td></tr>
<tr class="memdesc:a955fc6683d49f3c5fc50c3e440da4669"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the alias for a Channel.  <a href="classOpenSim_1_1AbstractInput.html#a955fc6683d49f3c5fc50c3e440da4669">More...</a><br /></td></tr>
<tr class="separator:a955fc6683d49f3c5fc50c3e440da4669"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0f16471f64cc53a564c4cc65c4b93fc4"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractInput.html#a0f16471f64cc53a564c4cc65c4b93fc4">setAlias</a> (unsigned index, const std::string &amp;alias)=0</td></tr>
<tr class="memdesc:a0f16471f64cc53a564c4cc65c4b93fc4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the alias for the Channel indicated by the provided index.  <a href="classOpenSim_1_1AbstractInput.html#a0f16471f64cc53a564c4cc65c4b93fc4">More...</a><br /></td></tr>
<tr class="separator:a0f16471f64cc53a564c4cc65c4b93fc4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1e278ba638b578a915c90df79db1d767"><td class="memItemLeft" align="right" valign="top">virtual std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractInput.html#a1e278ba638b578a915c90df79db1d767">getLabel</a> () const =0</td></tr>
<tr class="memdesc:a1e278ba638b578a915c90df79db1d767"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the label for this Channel.  <a href="classOpenSim_1_1AbstractInput.html#a1e278ba638b578a915c90df79db1d767">More...</a><br /></td></tr>
<tr class="separator:a1e278ba638b578a915c90df79db1d767"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5cafe8e84c4138b10b50e17b73e6863f"><td class="memItemLeft" align="right" valign="top">virtual std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractInput.html#a5cafe8e84c4138b10b50e17b73e6863f">getLabel</a> (unsigned index) const =0</td></tr>
<tr class="memdesc:a5cafe8e84c4138b10b50e17b73e6863f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the label for the Channel indicated by the provided index.  <a href="classOpenSim_1_1AbstractInput.html#a5cafe8e84c4138b10b50e17b73e6863f">More...</a><br /></td></tr>
<tr class="separator:a5cafe8e84c4138b10b50e17b73e6863f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classOpenSim_1_1AbstractSocket"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classOpenSim_1_1AbstractSocket')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classOpenSim_1_1AbstractSocket.html">OpenSim::AbstractSocket</a></td></tr>
<tr class="memitem:a868b675e08eb429427ec1d0d95338ed8 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#a868b675e08eb429427ec1d0d95338ed8">~AbstractSocket</a> ()</td></tr>
<tr class="separator:a868b675e08eb429427ec1d0d95338ed8 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5222469e0ef65d0dad0d7d0788a6c177 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">const std::string &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#a5222469e0ef65d0dad0d7d0788a6c177">getName</a> () const</td></tr>
<tr class="separator:a5222469e0ef65d0dad0d7d0788a6c177 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a881ce4fb9bf97d3b715100c8ce3b80b2 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">SimTK::Stage&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#a881ce4fb9bf97d3b715100c8ce3b80b2">getConnectAtStage</a> () const</td></tr>
<tr class="memdesc:a881ce4fb9bf97d3b715100c8ce3b80b2 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the system Stage when the connection should be made.  <a href="classOpenSim_1_1AbstractSocket.html#a881ce4fb9bf97d3b715100c8ce3b80b2">More...</a><br /></td></tr>
<tr class="separator:a881ce4fb9bf97d3b715100c8ce3b80b2 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0dec27d1742c1e67753e673023299b03 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#a0dec27d1742c1e67753e673023299b03">isListSocket</a> () const</td></tr>
<tr class="memdesc:a0dec27d1742c1e67753e673023299b03 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Can this <a class="el" href="classOpenSim_1_1Socket.html">Socket</a> have more than one connectee?  <a href="classOpenSim_1_1AbstractSocket.html#a0dec27d1742c1e67753e673023299b03">More...</a><br /></td></tr>
<tr class="separator:a0dec27d1742c1e67753e673023299b03 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4fc29c560fa59cbb29da0cdf4cf01ffe inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#a4fc29c560fa59cbb29da0cdf4cf01ffe">getNumConnectees</a> () const</td></tr>
<tr class="memdesc:a4fc29c560fa59cbb29da0cdf4cf01ffe inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">The number of slots to fill in order to satisfy this socket.  <a href="classOpenSim_1_1AbstractSocket.html#a4fc29c560fa59cbb29da0cdf4cf01ffe">More...</a><br /></td></tr>
<tr class="separator:a4fc29c560fa59cbb29da0cdf4cf01ffe inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a20d1a94495d9e45850004cab9b91b1f7 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#a20d1a94495d9e45850004cab9b91b1f7">isConnected</a> () const =0</td></tr>
<tr class="memdesc:a20d1a94495d9e45850004cab9b91b1f7 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Derived classes must satisfy this Interface.  <a href="classOpenSim_1_1AbstractSocket.html#a20d1a94495d9e45850004cab9b91b1f7">More...</a><br /></td></tr>
<tr class="separator:a20d1a94495d9e45850004cab9b91b1f7 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8bd9bdc7613c88f6f92e9c53d3e6bd99 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">virtual std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#a8bd9bdc7613c88f6f92e9c53d3e6bd99">getConnecteeTypeName</a> () const =0</td></tr>
<tr class="memdesc:a8bd9bdc7613c88f6f92e9c53d3e6bd99 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the type of object this socket connects to.  <a href="classOpenSim_1_1AbstractSocket.html#a8bd9bdc7613c88f6f92e9c53d3e6bd99">More...</a><br /></td></tr>
<tr class="separator:a8bd9bdc7613c88f6f92e9c53d3e6bd99 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab7f51d3c1a841f4e3f00b38fee88c75e inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">virtual const <a class="el" href="classOpenSim_1_1Object.html">Object</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#ab7f51d3c1a841f4e3f00b38fee88c75e">getConnecteeAsObject</a> () const</td></tr>
<tr class="memdesc:ab7f51d3c1a841f4e3f00b38fee88c75e inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Generic access to the connectee.  <a href="classOpenSim_1_1AbstractSocket.html#ab7f51d3c1a841f4e3f00b38fee88c75e">More...</a><br /></td></tr>
<tr class="separator:ab7f51d3c1a841f4e3f00b38fee88c75e inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae783a456133f011142508e0fb9a0711c inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#ae783a456133f011142508e0fb9a0711c">findAndConnect</a> (const <a class="el" href="classOpenSim_1_1ComponentPath.html">ComponentPath</a> &amp;connectee)</td></tr>
<tr class="memdesc:ae783a456133f011142508e0fb9a0711c inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Find the connectee using a search with a partial path.  <a href="classOpenSim_1_1AbstractSocket.html#ae783a456133f011142508e0fb9a0711c">More...</a><br /></td></tr>
<tr class="separator:ae783a456133f011142508e0fb9a0711c inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2dccd9cd45ca0b08a4c13177dc5410bb inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#a2dccd9cd45ca0b08a4c13177dc5410bb">findAndConnect</a> (const std::string &amp;connectee)</td></tr>
<tr class="memdesc:a2dccd9cd45ca0b08a4c13177dc5410bb inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Same as <a class="el" href="classOpenSim_1_1AbstractSocket.html#ae783a456133f011142508e0fb9a0711c" title="Find the connectee using a search with a partial path.">findAndConnect(const ComponentPath&amp;)</a>, but using a string argument.  <a href="classOpenSim_1_1AbstractSocket.html#a2dccd9cd45ca0b08a4c13177dc5410bb">More...</a><br /></td></tr>
<tr class="separator:a2dccd9cd45ca0b08a4c13177dc5410bb inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a182a30262260a0503336a0d13d4b6c8d inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#a182a30262260a0503336a0d13d4b6c8d">finalizeConnection</a> (const <a class="el" href="classOpenSim_1_1Component.html">Component</a> &amp;root)</td></tr>
<tr class="memdesc:a182a30262260a0503336a0d13d4b6c8d inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Connect this Socket according to its connectee path property given a root Component to search its subcomponents for the connect_to <a class="el" href="classOpenSim_1_1Component.html" title="The abstract Component class defines the interface used to add computational elements to the underlyi...">Component</a>.  <a href="classOpenSim_1_1AbstractSocket.html#a182a30262260a0503336a0d13d4b6c8d">More...</a><br /></td></tr>
<tr class="separator:a182a30262260a0503336a0d13d4b6c8d inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac657088c315af6dc49b762d2acb81657 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#ac657088c315af6dc49b762d2acb81657">disconnect</a> ()=0</td></tr>
<tr class="memdesc:ac657088c315af6dc49b762d2acb81657 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Clear references to connectees.  <a href="classOpenSim_1_1AbstractSocket.html#ac657088c315af6dc49b762d2acb81657">More...</a><br /></td></tr>
<tr class="separator:ac657088c315af6dc49b762d2acb81657 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af76f658a08e1f323665eee8e90d1a7a9 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#af76f658a08e1f323665eee8e90d1a7a9">setConnecteePath</a> (const std::string &amp;name)</td></tr>
<tr class="memdesc:af76f658a08e1f323665eee8e90d1a7a9 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set connectee path.  <a href="classOpenSim_1_1AbstractSocket.html#af76f658a08e1f323665eee8e90d1a7a9">More...</a><br /></td></tr>
<tr class="separator:af76f658a08e1f323665eee8e90d1a7a9 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7dd2d3233598f23465b4d6afbf19bd7a inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#a7dd2d3233598f23465b4d6afbf19bd7a">setConnecteePath</a> (const std::string &amp;name, unsigned ix)</td></tr>
<tr class="memdesc:a7dd2d3233598f23465b4d6afbf19bd7a inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set connectee path of a connectee among a list of connectees.  <a href="classOpenSim_1_1AbstractSocket.html#a7dd2d3233598f23465b4d6afbf19bd7a">More...</a><br /></td></tr>
<tr class="separator:a7dd2d3233598f23465b4d6afbf19bd7a inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaf113a0c1e31f3b28dc732928d684a06 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">const std::string &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#aaf113a0c1e31f3b28dc732928d684a06">getConnecteePath</a> () const</td></tr>
<tr class="memdesc:aaf113a0c1e31f3b28dc732928d684a06 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get connectee path.  <a href="classOpenSim_1_1AbstractSocket.html#aaf113a0c1e31f3b28dc732928d684a06">More...</a><br /></td></tr>
<tr class="separator:aaf113a0c1e31f3b28dc732928d684a06 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8cdf1ea4b8795edf8a8d1e0106707538 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">const std::string &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#a8cdf1ea4b8795edf8a8d1e0106707538">getConnecteePath</a> (unsigned ix) const</td></tr>
<tr class="memdesc:a8cdf1ea4b8795edf8a8d1e0106707538 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get connectee path of a connectee among a list of connectees.  <a href="classOpenSim_1_1AbstractSocket.html#a8cdf1ea4b8795edf8a8d1e0106707538">More...</a><br /></td></tr>
<tr class="separator:a8cdf1ea4b8795edf8a8d1e0106707538 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afd80d0f355163910daea30d26a394430 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#afd80d0f355163910daea30d26a394430">appendConnecteePath</a> (const std::string &amp;name)</td></tr>
<tr class="separator:afd80d0f355163910daea30d26a394430 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac86784a65efd79dc1aad7f759b2b8cd9 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#ac86784a65efd79dc1aad7f759b2b8cd9">clearConnecteePath</a> ()</td></tr>
<tr class="memdesc:ac86784a65efd79dc1aad7f759b2b8cd9 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Clear all connectee paths in the connectee path property.  <a href="classOpenSim_1_1AbstractSocket.html#ac86784a65efd79dc1aad7f759b2b8cd9">More...</a><br /></td></tr>
<tr class="separator:ac86784a65efd79dc1aad7f759b2b8cd9 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8e98fd9f05712a934982f1ffba94ffe2 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memItemLeft" align="right" valign="top">const <a class="el" href="classOpenSim_1_1Component.html">Component</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractSocket.html#a8e98fd9f05712a934982f1ffba94ffe2">getOwner</a> () const</td></tr>
<tr class="memdesc:a8e98fd9f05712a934982f1ffba94ffe2 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get owner component of this socket.  <a href="classOpenSim_1_1AbstractSocket.html#a8e98fd9f05712a934982f1ffba94ffe2">More...</a><br /></td></tr>
<tr class="separator:a8e98fd9f05712a934982f1ffba94ffe2 inherit pub_methods_classOpenSim_1_1AbstractSocket"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:a2062b6259d1871de344a63341f19f53d"><td class="memItemLeft" align="right" valign="top">static bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractInput.html#a2062b6259d1871de344a63341f19f53d">parseConnecteePath</a> (const std::string &amp;connecteePath, std::string &amp;componentPath, std::string &amp;outputName, std::string &amp;channelName, std::string &amp;alias)</td></tr>
<tr class="memdesc:a2062b6259d1871de344a63341f19f53d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Break up a connectee path into its output path, channel name (empty for single-value outputs), and alias.  <a href="classOpenSim_1_1AbstractInput.html#a2062b6259d1871de344a63341f19f53d">More...</a><br /></td></tr>
<tr class="separator:a2062b6259d1871de344a63341f19f53d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad11e499265b50f69bcaa3af34b972ad9"><td class="memItemLeft" align="right" valign="top">static std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1AbstractInput.html#ad11e499265b50f69bcaa3af34b972ad9">composeConnecteePath</a> (const std::string &amp;componentPath, const std::string &amp;outputName, const std::string &amp;channelName, const std::string &amp;alias)</td></tr>
<tr class="memdesc:ad11e499265b50f69bcaa3af34b972ad9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compose the connectee path from its constituents.  <a href="classOpenSim_1_1AbstractInput.html#ad11e499265b50f69bcaa3af34b972ad9">More...</a><br /></td></tr>
<tr class="separator:ad11e499265b50f69bcaa3af34b972ad9"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description </h2>
<div class="textblock"><p>A specialized <a class="el" href="classOpenSim_1_1Socket.html">Socket</a> that connects to an <a class="el" href="classOpenSim_1_1Output.html">Output</a> signal is an <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a>. </p>
<p>An <a class="el" href="classOpenSim_1_1AbstractInput.html" title="A specialized Socket that connects to an Output signal is an Input.">AbstractInput</a> enables maintenance of a list of unconnected Inputs. An <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a> can either be a single-value <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a> or a list <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a>. A list <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a> can connect to multiple (<a class="el" href="classOpenSim_1_1Output.html">Output</a>) Channels.</p>
<h4><a class="anchor" id="autotoc_md7"></a>
XML Syntax of a connectee path</h4>
<p>For every Input that a component has, the XML representation of the component contains an element named <code>input_&lt;input_name&gt;</code>. For example, a component that has an <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a> named <code>desired_angle</code> might look like the following in XML: </p><div class="fragment"><div class="line">&lt;MyComponent name=<span class="stringliteral">&quot;my_comp&quot;</span>&gt;</div>
<div class="line">    &lt;input_desired_angle&gt;</div>
<div class="line">        ../foo/angle</div>
<div class="line">    &lt;/input_desired_angle&gt;</div>
<div class="line">    ...</div>
<div class="line">&lt;/MyComponent&gt;</div>
</div><!-- fragment --><p> You use this field to specify the outputs/channels that should be connected to this input (that is, the connectees). The syntax for the connectee path property is as follows: </p><div class="fragment"><div class="line">&lt;path/to/component&gt;|&lt;output_name&gt;[:&lt;channel_name&gt;][(&lt;alias&gt;)]</div>
</div><!-- fragment --><p> Angle brackets indicate fields that one would fill in, and square brackets indicate optional fields. The <code>&lt;path/to/component&gt;</code> can be relative or absolute, and describes the location of the <a class="el" href="classOpenSim_1_1Component.html" title="The abstract Component class defines the interface used to add computational elements to the underlyi...">Component</a> that contains the desired <a class="el" href="classOpenSim_1_1Output.html">Output</a> relative to the location of the <a class="el" href="classOpenSim_1_1Component.html" title="The abstract Component class defines the interface used to add computational elements to the underlyi...">Component</a> that contains this <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a>. The <code>&lt;path/to/component&gt;</code> and <code>&lt;output_name&gt;</code> must always be specified. The <code>&lt;channel_name&gt;</code> should only be specified if the Output is a list output (i.e., it has multiple channels). The <code>&lt;alias&gt;</code> is a name for the output/channel that is specific to this input, and it is optional. All fields should contain only letters, numbers, and underscores (the path to the component can contain slashes and periods); fields must <em>not</em> contain spaces. Here are some examples:</p><ul>
<li><code>../marker_data|column:left_ankle</code>: The TableSourceVec3 component <code>../marker_data</code> has a list output <code>column</code>, and we want to connect to its <code>left_ankle</code> channel.</li>
<li><code>../averager|output(knee_joint_center)</code>: The component <code>../averager</code> (presumably a component that averages its inputs) has an output named <code>output</code>, and we are aliasing this output as <code>knee_joint_center</code>.</li>
<li><code>/leg_model/soleus|activation</code>: This connectee path uses the absolute path to component <code>soleus</code>, which has an output named <code>activation</code>.</li>
</ul>
<p>List inputs can contain multiple entries in its connectee path, with the entries separated by a space. For example: </p><div class="fragment"><div class="line">&lt;input_experimental_markers&gt;</div>
<div class="line">    ../marker_data|column:left_ankle ../marker_data|column:right_ankle ../averager|output(knee_joint_center)</div>
<div class="line">&lt;/input_experimental_markers&gt;</div>
</div><!-- fragment --> </div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="aa5c9e6000a9e9f55c94e359e797bca33"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa5c9e6000a9e9f55c94e359e797bca33">&#9670;&nbsp;</a></span>~AbstractInput()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual OpenSim::AbstractInput::~AbstractInput </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a06eb42bd617876d5a68e211e7daf8004"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a06eb42bd617876d5a68e211e7daf8004">&#9670;&nbsp;</a></span>AbstractInput()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">OpenSim::AbstractInput::AbstractInput </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const PropertyIndex &amp;&#160;</td>
          <td class="paramname"><em>connecteePathIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const SimTK::Stage &amp;&#160;</td>
          <td class="paramname"><em>connectAtStage</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOpenSim_1_1Component.html">Component</a> &amp;&#160;</td>
          <td class="paramname"><em>owner</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Create an <a class="el" href="classOpenSim_1_1AbstractInput.html" title="A specialized Socket that connects to an Output signal is an Input.">AbstractInput</a> (<a class="el" href="classOpenSim_1_1Socket.html">Socket</a>) that connects only to an <a class="el" href="classOpenSim_1_1AbstractOutput.html" title="Output formalizes the access to a value of interest computed by the owning Component.">AbstractOutput</a> specified by name and stage at which it should be connected. </p>
<p>Only <a class="el" href="classOpenSim_1_1Component.html" title="The abstract Component class defines the interface used to add computational elements to the underlyi...">Component</a> should ever construct this class. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">name</td><td>name of the dependent (Abstract)<a class="el" href="classOpenSim_1_1Output.html">Output</a>. </td></tr>
    <tr><td class="paramname">connecteePathIndex</td><td>Index of the property in the containing <a class="el" href="classOpenSim_1_1Component.html" title="The abstract Component class defines the interface used to add computational elements to the underlyi...">Component</a> that holds this <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a>'s connectee path(s). </td></tr>
    <tr><td class="paramname">connectAtStage</td><td>Stage at which <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a> should be connected. </td></tr>
    <tr><td class="paramname">owner</td><td>The component that contains this input. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a1495e040f3e49a876a554dafd0f44e80"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1495e040f3e49a876a554dafd0f44e80">&#9670;&nbsp;</a></span>clone()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOpenSim_1_1AbstractInput.html">AbstractInput</a>* OpenSim::AbstractInput::clone </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Create a dynamically-allocated copy. </p>
<p>You must manage the memory for the returned pointer. This function exists to facilitate the use of SimTK::ClonePtr&lt;AbstractSocket&gt;. </p>

<p>Implements <a class="el" href="classOpenSim_1_1AbstractSocket.html#afa09afbf55e0e2feb0ebb83e446ab507">OpenSim::AbstractSocket</a>.</p>

<p>Implemented in <a class="el" href="classOpenSim_1_1Input.html#a60818c34161d77ea849d7f8e1e3cb2ee">OpenSim::Input&lt; T &gt;</a>.</p>

</div>
</div>
<a id="ad11e499265b50f69bcaa3af34b972ad9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad11e499265b50f69bcaa3af34b972ad9">&#9670;&nbsp;</a></span>composeConnecteePath()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static std::string OpenSim::AbstractInput::composeConnecteePath </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>componentPath</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>outputName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>channelName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>alias</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Compose the connectee path from its constituents. </p>
<p>This is the opposite operation of <a class="el" href="classOpenSim_1_1AbstractInput.html#a2062b6259d1871de344a63341f19f53d" title="Break up a connectee path into its output path, channel name (empty for single-value outputs),...">parseConnecteePath()</a>. Example: </p><pre class="fragment"> if inputs are
   componentPath --&gt; "/foo/bar"
   outputName    --&gt; "output"
   channelName   --&gt; "channel"
   alias         --&gt; "baz"
 then result --&gt; /foo/bar|output:channel(baz)
</pre> 
<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1Input.html#a1cda1dcc80abf531b0217f6d3316ed80">OpenSim::Input&lt; T &gt;::setAlias()</a>.</p>

</div>
</div>
<a id="ae5efc02a932f1418e6c5f275404258b1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae5efc02a932f1418e6c5f275404258b1">&#9670;&nbsp;</a></span>connect() <span class="overload">[1/3]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void OpenSim::AbstractInput::connect </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1AbstractChannel.html">AbstractChannel</a> &amp;&#160;</td>
          <td class="paramname"><em>channel</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>alias</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Connect this <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a> to a single output channel. </p>
<p>This method can be used with both single-valued and list Inputs. You can optionally provide an alias that will be used by the <a class="el" href="classOpenSim_1_1Component.html" title="The abstract Component class defines the interface used to add computational elements to the underlyi...">Component</a> owning this Input to refer to the Channel. </p>

<p>Implemented in <a class="el" href="classOpenSim_1_1Input.html#ac76e261f646e7874b8c6d3cee808f9f3">OpenSim::Input&lt; T &gt;</a>.</p>

</div>
</div>
<a id="a0877b842472ab90608a3c0e761878f56"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0877b842472ab90608a3c0e761878f56">&#9670;&nbsp;</a></span>connect() <span class="overload">[2/3]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void OpenSim::AbstractInput::connect </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1AbstractOutput.html">AbstractOutput</a> &amp;&#160;</td>
          <td class="paramname"><em>output</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>alias</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>TODO. </p>
<p>Connect this <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a> to a single-valued (single-channel) <a class="el" href="classOpenSim_1_1Output.html">Output</a> or, if this is a list Input and the Output is a list Output, connect to all the channels of the Output. You can optionally provide an alias that will be used by the <a class="el" href="classOpenSim_1_1Component.html" title="The abstract Component class defines the interface used to add computational elements to the underlyi...">Component</a> owning this Input to refer to the Output. If this method connects to multiple channels, the alias will be used for all channels. </p>

<p>Implemented in <a class="el" href="classOpenSim_1_1Input.html#a958819e04ea16dfdd2f21aded9fc1620">OpenSim::Input&lt; T &gt;</a>.</p>

</div>
</div>
<a id="a10ae90fa015c07916d0986efe5e77144"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a10ae90fa015c07916d0986efe5e77144">&#9670;&nbsp;</a></span>connect() <span class="overload">[3/3]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void OpenSim::AbstractInput::connect </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1Object.html">Object</a> &amp;&#160;</td>
          <td class="paramname"><em>connectee</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Connect this Socket to the provided connectee object. </p>
<p>If this is a list socket, the connectee is appended to the list of connectees; otherwise, the provided connectee replaces the single connectee. </p>

<p>Implements <a class="el" href="classOpenSim_1_1AbstractSocket.html#a48433b70cf9c41732ba587c9b5a1c25b">OpenSim::AbstractSocket</a>.</p>

</div>
</div>
<a id="a1745b26a3e3263f5cafce0d4074cb809"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1745b26a3e3263f5cafce0d4074cb809">&#9670;&nbsp;</a></span>getAlias() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual const std::string&amp; OpenSim::AbstractInput::getAlias </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get the alias for a Channel. </p>
<p>An alias is a description for a Channel that is specific to how the <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a> will use the Channel. For example, the <a class="el" href="classOpenSim_1_1Component.html" title="The abstract Component class defines the interface used to add computational elements to the underlyi...">Component</a> that owns this Input might expect the aliases to be the names of markers in the model. This method can be used only for non-list Inputs; for list Inputs, use the overload that takes an index. You must finalize connections (Component::finalizeConnections()) first. </p>

<p>Implemented in <a class="el" href="classOpenSim_1_1Input.html#a15519bc6a26bed98722bea0161173745">OpenSim::Input&lt; T &gt;</a>.</p>

</div>
</div>
<a id="a667e6b607e3d3b95fa768971219efd23"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a667e6b607e3d3b95fa768971219efd23">&#9670;&nbsp;</a></span>getAlias() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual const std::string&amp; OpenSim::AbstractInput::getAlias </td>
          <td>(</td>
          <td class="paramtype">unsigned&#160;</td>
          <td class="paramname"><em>index</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get the alias for the Channel indicated by the provided index. </p>
<p>An alias is a description for a Channel that is specific to how the <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a> will use the Channel. For example, the <a class="el" href="classOpenSim_1_1Component.html" title="The abstract Component class defines the interface used to add computational elements to the underlyi...">Component</a> that owns this Input might expect the aliases to be the names of markers in the model. You must finalize connections (Component::finalizeConnections()) first. </p>

<p>Implemented in <a class="el" href="classOpenSim_1_1Input.html#ab3840d2041f8502ede51f07aa6ec6896">OpenSim::Input&lt; T &gt;</a>.</p>

</div>
</div>
<a id="a1e278ba638b578a915c90df79db1d767"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1e278ba638b578a915c90df79db1d767">&#9670;&nbsp;</a></span>getLabel() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual std::string OpenSim::AbstractInput::getLabel </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get the label for this Channel. </p>
<p>If an alias has been set, the label is the alias; otherwise, the label is the full path of the <a class="el" href="classOpenSim_1_1Output.html">Output</a> that has been connected to this <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a>. This method can be used only for non-list Inputs; for list Inputs, use the single-argument overload. You must finalize connections (Component::finalizeConnections()) first. </p>

<p>Implemented in <a class="el" href="classOpenSim_1_1Input.html#aa5b6a623cc874ead09c9ff439af95627">OpenSim::Input&lt; T &gt;</a>.</p>

</div>
</div>
<a id="a5cafe8e84c4138b10b50e17b73e6863f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5cafe8e84c4138b10b50e17b73e6863f">&#9670;&nbsp;</a></span>getLabel() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual std::string OpenSim::AbstractInput::getLabel </td>
          <td>(</td>
          <td class="paramtype">unsigned&#160;</td>
          <td class="paramname"><em>index</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get the label for the Channel indicated by the provided index. </p>
<p>If an alias has been set, the label is the alias; otherwise, the label is the full path of the Channel that has been connected to this <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a>. You must finalize connections (Component::finalizeConnections()) first. </p>

<p>Implemented in <a class="el" href="classOpenSim_1_1Input.html#a870abe650f0cc83ff13fedbb60122696">OpenSim::Input&lt; T &gt;</a>.</p>

</div>
</div>
<a id="a2062b6259d1871de344a63341f19f53d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2062b6259d1871de344a63341f19f53d">&#9670;&nbsp;</a></span>parseConnecteePath()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static bool OpenSim::AbstractInput::parseConnecteePath </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>connecteePath</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string &amp;&#160;</td>
          <td class="paramname"><em>componentPath</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string &amp;&#160;</td>
          <td class="paramname"><em>outputName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string &amp;&#160;</td>
          <td class="paramname"><em>channelName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string &amp;&#160;</td>
          <td class="paramname"><em>alias</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Break up a connectee path into its output path, channel name (empty for single-value outputs), and alias. </p>
<p>This function writes to the passed-in outputPath, channelName, and alias.</p>
<p>Examples: </p><pre class="fragment">/foo/bar|output
outputPath is "/foo/bar/output"
channelName is ""
alias is ""

/foo/bar|output:channel
outputPath is "/foo/bar/output"
channelName is "channel"
alias is ""

/foo/bar|output(baz)
outputPath is "/foo/bar/output"
channelName is ""
alias is "baz"

/foo/bar|output:channel(baz)
outputPath is "/foo/bar|output"
channelName is "channel"
alias is "baz"
</pre> 
<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1Input.html#a1cda1dcc80abf531b0217f6d3316ed80">OpenSim::Input&lt; T &gt;::setAlias()</a>.</p>

</div>
</div>
<a id="a955fc6683d49f3c5fc50c3e440da4669"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a955fc6683d49f3c5fc50c3e440da4669">&#9670;&nbsp;</a></span>setAlias() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void OpenSim::AbstractInput::setAlias </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>alias</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Set the alias for a Channel. </p>
<p>If this is a list <a class="el" href="classOpenSim_1_1Input.html" title="An Input&lt;Y&gt; must be connected by an Output&lt;Y&gt;">Input</a>, the aliases of all Channels will be set to the provided string. If you wish to set the alias of only one Channel, use the two-argument overload. You must finalize connections (Component::finalizeConnections()) first. </p>

<p>Implemented in <a class="el" href="classOpenSim_1_1Input.html#a52daca458b43b17ee594231fce365f1b">OpenSim::Input&lt; T &gt;</a>.</p>

</div>
</div>
<a id="a0f16471f64cc53a564c4cc65c4b93fc4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0f16471f64cc53a564c4cc65c4b93fc4">&#9670;&nbsp;</a></span>setAlias() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void OpenSim::AbstractInput::setAlias </td>
          <td>(</td>
          <td class="paramtype">unsigned&#160;</td>
          <td class="paramname"><em>index</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>alias</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Set the alias for the Channel indicated by the provided index. </p>
<p>You must finalize connections (Component::finalizeConnections()) first. </p>

<p>Implemented in <a class="el" href="classOpenSim_1_1Input.html#a1cda1dcc80abf531b0217f6d3316ed80">OpenSim::Input&lt; T &gt;</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>OpenSim/Common/ComponentSocket.h</li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespaceOpenSim.html">OpenSim</a></li><li class="navelem"><a class="el" href="classOpenSim_1_1AbstractInput.html">AbstractInput</a></li>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:40 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
